package tc65Test;

import java.io.*;
import javax.microedition.io.Connector;

import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;
import com.siemens.icm.io.file.*;

/**
 *      -.
 *      Enter,  
 *   ,  .
 *
 * Author: "Dmitry" <info@gsmpager.spb.ru>
 *
 */

public class MenuSettings extends Thread 
{
	//  ,       
	Tc65SerialPort 	tc65SerialPort;
	ATCommand 		atCommand;
	
	//     
	public static final char MS_TIMEOUT 	= 65535; //  : 
	public static final char MS_NODATA 	= 0;  //   ProcessMenu,   .
	
	//  ProcessMenu() -  -  
	public static final int MS_HAVEATCMD= 2;  
	public static final int MS_EXITPROG	= 1; //  ProcessMenu() -    
	public static final int MS_DONTEXIT	= 0; 

	//    
	int MenuTimeout = 0;
	int CurrMenu = 0; //    (0 -  )
	
	//  
	String Number1; //   
	boolean SendTestSMS = false;
	
	boolean FillingBuffer = false; //   -    ENTER
	StringBuffer strBuf; //     
	int idxInputBuffer = 0; //      
	int NowFillingValue = 0; //  ,      

	// -,   ,  ProcessMenu()  MS_HAVEATCMD
	String atCmd2Execute;
	
	public MenuSettings(Tc65SerialPort tc65SerialPort, ATCommand atCommand)
	{
		this.tc65SerialPort = tc65SerialPort;
		this.atCommand = atCommand;
		strBuf = new StringBuffer(40);
		atCmd2Execute = new String();
		Number1 = new String("(not set)");
		//  
        //start(); -     
	}
	
	public void run() 
	{
		LoadFromFile();
		try 
		{
			do
			{
				sleep(50);
				int ch;
				if(tc65SerialPort.hasData() > 0)
				{
				    ch = tc65SerialPort.readByte();
				    if (ch >= 0) 
				    {
				    	int retcode = ProcessMenu((char)ch);
				    	
				    	if(retcode == MS_EXITPROG)
				    	{
					    	close();
					    	break;
				    	}
				    	else
				    	{
				    		if(retcode == MS_HAVEATCMD)
				    		{
				    			try {
				    				atCommand.send(atCmd2Execute);
								} catch (IllegalStateException e) {
									e.printStackTrace();
								} catch (IllegalArgumentException e) {
									e.printStackTrace();
								} catch (ATCommandFailedException e) {
									e.printStackTrace();
								}
				    		}
				    			
				    	}
				    }
				}
				else 
					ProcessMenu(MS_NODATA);
				
				//     
				if(MenuTimeout >= 30)
				{
					if(MenuTimeout == 30)
						ProcessMenu(MS_TIMEOUT);
					if(MenuTimeout >= 100)
						MenuTimeout = 31;
					CurrMenu = 0; //  
				}
				
			}
			while(true);
		} 
		catch (InterruptedException e) 
		{
			tc65SerialPort.serialOut("InterruptedException, closing MenuSettings thread");
			close();
		}
	}
	
	public void close()
	{
		//  ,     - - 
		//    .
		tc65SerialPort.serialOut("\n\rTC65 test Java app application finished\n\r");
		System.out.println("Streams and connection closed");
	}
/**
 *   -   (       - 0)
 *  1 -   
 *  2 -  
 *  	1 -    
 *  	8 -     
 *  8 - -
 *  	1 -  GPIO0 = 1
 *  	2 -  GPIO0 = 0
 *  	5 -   
 *  	0 -   
 *  9 -   
 *  0 -   

 * @param NextEntered
 * @return
 */
	int ProcessMenu(char NextEntered)
	{
		boolean StopProcessing = false; //   false,    .
		int retval = MS_DONTEXIT; //  
		
		if(NextEntered == MS_NODATA) //    
		{
			StopProcessing = true;
			//    
		}
		
		while(StopProcessing == false)
		{
			StopProcessing = true;
			MenuTimeout = 0; //  ,  - 
			switch(CurrMenu)
			{
			// ******************* Menu 0-0 ******************
			case 0: //   
				if(NextEntered == 0x0d) //  Enter
				{
					CurrMenu = 1; //    1    Enter
					StopProcessing = false;
				}
				break;
			// ******************* Menu 0-1 ******************
			case 1: //    
				switch(NextEntered)
				{
				case '1': //"1 -  \n\r" 
					DisplaySettings();
					break;
				case '2': //"2 -  \n\r"
					CurrMenu = 12;
					StopProcessing = false; //   . 
					NextEntered = 0x0d; //   ENTER
					break;
				case '8': //"8 - test menu\n\r"
					CurrMenu = 8;
					StopProcessing = false; //   . 
					NextEntered = 0x0d; //   ENTER
					break;
				case '9': //"9 -   \n\r"
					CurrMenu = 9;
					tc65SerialPort.serialOut("ARE YOU SURE? Press \"6\" to confirm.\n\r");
					break;
				case '0': //"0 -   \n\r"
					break;
				case 0x0d: // Enter
					tc65SerialPort.serialOut(	"TC65 menu\n\r" +
							"-----------------\n\r" +
							"1 - Display settings\n\r" +
							"2 - Change settings\n\r" +
							"8 - I/O menu\n\r" +
							"9 - Exit Java APPLICATION\n\r" +
							"0 - Exit menu\n\r\n\r");
					break;
				default:
					tc65SerialPort.serialOut("Unknown command! Press Enter to display menu.\r\n");					
					break;
				}

				break;
			// ******************* Menu 0-8 ******************
			case 8:
				switch(NextEntered)
				{
				case '1': //1 - Set GPIO0=1 
					atCmd2Execute = "AT^SSIO=0,1\r";
					retval = MS_HAVEATCMD;
					break;
				case '2': //2 - Set GPIO0=0
					atCmd2Execute = "AT^SSIO=0,0\r";
					retval = MS_HAVEATCMD;
					break;
				case '5': //5 - Send test SMS
					SendTestSMS = true;
					break;
				case '0': //"0 -   \n\r"
					CurrMenu = 1; //    
					NextEntered = 0x0d;
					StopProcessing = false;
					break;
				case 0x0d: // Enter
					tc65SerialPort.serialOut(	"I/O menu\n\r" +
							"-----------------\n\r" +
							"1 - Set GPIO0=1\n\r" +
							"2 - Set GPIO0=0\n\r" +
							"5 - Send test SMS in Russian (UCS2)\n\r" +
							"0 - Exit menu\n\r\n\r");
					break;
				default:
					tc65SerialPort.serialOut("Unknown command! Press Enter to display menu.\r\n");					
					break;
				}
				break;
			// ******************* Menu 0-9 ******************
			case 9: //     
				if(NextEntered == '6') //  
					return MS_EXITPROG;
				else
					CurrMenu = 1; //   .
				break;

			// ******************* Menu 1-2 ******************
				
			case 12:
				//     
				if(FillingBuffer)
				{
					//    
					if(NextEntered > ' ')
					{
						if(idxInputBuffer < 39) //      1
						{
							//InputBuffer[idxInputBuffer] = NextEntered;
							strBuf.append(NextEntered);
							idxInputBuffer++;
							//ByteArrayInputStream bais = new ByteArrayInputStream(InputBuffer); 
							tc65SerialPort.serialOut(NextEntered);
						}
						else //   ,  
						{
							FillingBuffer = false;
							//InputBuffer[idxInputBuffer] = 0;
							NextEntered = 0x0d; //   
						}
					}
					else //    ENTER
					{
						FillingBuffer = false;
						//InputBuffer[idxInputBuffer] = 0;
						NextEntered = 0x0d; //   

						tc65SerialPort.serialOut("\n\rDEBUG: Entered " + /*InputBuffer.toString()*/ strBuf.toString() + "\n\r");
						//    ,  
						switch(NowFillingValue)
						{
						case 1: // 
							if(idxInputBuffer > 0)
								Number1 = /*InputBuffer.*/strBuf.toString();
							tc65SerialPort.serialOut("\n\rNew telephone number: " + Number1 + "\n\r");
							break;
						}
					}
				}
				
				if(FillingBuffer == false)
				{
					idxInputBuffer = 0; // -   ... 
					switch(NextEntered)
					{
					case 0x0d:
						tc65SerialPort.serialOut(	"\n\rChange settings menu\n\r" +
								"-----------------\n\r" +
								"1 - Change telephone number\n\r" +
								"8 - Save settings to file\n\r" +
								"0 - Exit menu\n\r\n\r");
						break;
					case '1':
						NowFillingValue = 1;
						FillingBuffer = true;
						tc65SerialPort.serialOut("\n\rChange telephone number\n\r" +
									 "-----------------------\n\r" +
								"Current telephone number:" + Number1 + 
								"\n\rEnter new telephone number:\n\r");
						break;
					case '8':
						tc65SerialPort.serialOut("\n\rSave settings to file\n\r" +
									 "---------------------\n\r");
						SaveToFile();
						break;
					case '0':
						CurrMenu = 1; //    
						NextEntered = 0x0d;
						StopProcessing = false;
						break;
					default:
						tc65SerialPort.serialOut("Unknown command! Press Enter to display menu.\r\n\n\r");					
						break;
					}
					//    ?
					if(FillingBuffer == true)
						strBuf.delete(0, strBuf.length());
						
				} // else if(FillingBuffer)
				break;
			// ******************* default ******************
			default: //   
				tc65SerialPort.serialOut("ERROR! Bad CurrMenu value.\n\r");
				CurrMenu = 0; 
				NextEntered = MS_NODATA;
				break;
			}
		}

		return retval;
	}

/**
 *    
 *
 */	
	void DisplaySettings()
	{
		tc65SerialPort.serialOut(	"TC65 test Java app settings\n\r" +
				"-----------------\n\r" +
				"Telephone number: " + Number1 + "\n\r\n\r");
	}

/**
 *    
 */
	void LoadFromFile()
	{
		try 
		{
			FileConnection fconn = (FileConnection)Connector.open("file:///a:/tc65test.dat", 
					Connector.READ);
			// If no exception is thrown, then the URI is valid, but the file may or may not exist.
			if (fconn.exists())
			{
				long size = fconn.fileSize();
				tc65SerialPort.serialOut("\n\rtc65test.dat filesize="+size+"\n\r");
				if(size <14) //   - 11-12 
				{
					DataInputStream dis = fconn.openDataInputStream();
					Number1 = dis.readUTF();
				}
				else
					tc65SerialPort.serialOut("Probably wrong contents of settings file; using defaults\n\r");
			}
			else
				tc65SerialPort.serialOut("Settings file not found; using defaults\n\r");

			fconn.close();
		}
		catch (IOException ioe) 
		{
			tc65SerialPort.serialOut("File read operation error: " + ioe.getMessage() + "\n\r");
		}
	}

	/**
	 *    
	 */
	void SaveToFile()
	{
		try 
		{
			FileConnection fconn = (FileConnection)Connector.open("file:///a:/tc65test.dat");
			// If no exception is thrown, then the URI is valid, but the file may or may not exist.
			
			if (!fconn.exists())
			{
				fconn.create();  // create the file if it doesn't exist
			}

			if (fconn.exists())
			{
				fconn.truncate(0);
				DataOutputStream dos = fconn.openDataOutputStream();
				dos.writeUTF(Number1);
				tc65SerialPort.serialOut("\n\rThe \"tc65test.dat\" file has been saved to module file system\n\r");
			}
			else
				tc65SerialPort.serialOut("Could not create output file, settings not stored\n\r");
			
			fconn.close();
		}
		catch (IOException ioe) 
		{
			tc65SerialPort.serialOut("File write operation error: " + ioe.getMessage() + "\n\r");
		}
	}
}
